-- ==================================================================== --
-- SISTEMA         : PONTO DE VENDA                                     --
-- DATA DA CRIAO : INCIO - 30/10/2003                                --
-- CRIAO         : Gustavo Nosseis dos Santos                         --
-- OBJETIVOS       : Atualiza os saldos dos tickets                     --
-- @C:\WIN_PRJ\SQL\END_CONV\ORACLE\3800_PDVSTP_Atualiza_Saldo_Ticket.sql--
-- ==================================================================== --
CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_TICKET(
  P_CDFILIAL IN CTRLTPRECEB.CDFILIAL%TYPE,
  P_CDLOJA   IN CTRLTPRECEB.CDLOJA%TYPE,
  P_DATA     IN DATE

 )AS
  V_DTCTRLTPRECE  CTRLTPRECEB.DTCTRLTPRECE%TYPE;
  V_TIPOCALC      VARCHAR(1);
  V_CDFILIAL      VARCHAR(4);
  V_IDTPRECE      VARCHAR(1);
  V_REGMENORIGUAL NUMBER;
  V_VRMOVTPRECE   NUMBER;
  V_VRSALTPRECE   NUMBER;
  V_MAIORIGUAL    NUMBER;
  V_VRSALDOATUAL  NUMBER;
BEGIN
   IF P_CDLOJA = ' ' THEN
      V_TIPOCALC := '2';
   END IF;
   IF P_CDLOJA <> ' ' THEN
      V_TIPOCALC := '1';
   END IF;

   IF V_TIPOCALC = '1' THEN
      /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
      SELECT
         MIN(DTCTRLTPRECE)
      INTO V_DTCTRLTPRECE
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = P_CDFILIAL) AND
         (CDLOJA        = P_CDLOJA  ) AND
         (DTCTRLTPRECE >= P_DATA    );

      /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
      SELECT
         COUNT(DTCTRLTPRECE)
      INTO V_REGMENORIGUAL
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = P_CDFILIAL    ) AND
         (CDLOJA        = P_CDLOJA      ) AND
         (DTCTRLTPRECE <= V_DTCTRLTPRECE);

      /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio registro*/
      IF V_REGMENORIGUAL = 1 THEN

         /*Seleciona o registro*/
         SELECT
            CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
         INTO V_CDFILIAL, V_DTCTRLTPRECE, V_VRMOVTPRECE, V_IDTPRECE, V_VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL     = P_CDFILIAL    ) AND
            (CDLOJA       = P_CDLOJA      ) AND
            (DTCTRLTPRECE = V_DTCTRLTPRECE);

         IF V_IDTPRECE = 'D' THEN
            V_VRMOVTPRECE := (-1) * V_VRMOVTPRECE;
         END IF;

         /*Grava no valor do saldo, o valor da venda, visto que no h registro anterior*/
         UPDATE
            CTRLTPRECEB
         SET
            VRSALTPRECE  = V_VRMOVTPRECE
         WHERE
            (DTCTRLTPRECE = V_DTCTRLTPRECE) AND
            (CDLOJA       = P_CDLOJA      ) AND
            (CDFILIAL     = V_CDFILIAL    );

         /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
         SELECT
            COUNT(DTCTRLTPRECE)
         INTO V_MAIORIGUAL
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = P_CDFILIAL    ) AND
            (CDLOJA        = P_CDLOJA      ) AND
            (DTCTRLTPRECE >= V_DTCTRLTPRECE);

         /*Atualiza registross posteriores*/
         IF V_MAIORIGUAL > 1 THEN
            FOR CUR_CTRLTPRECEB IN (
               SELECT
                  CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = P_CDFILIAL    ) AND
                  (CDLOJA        = P_CDLOJA      ) AND
                  (DTCTRLTPRECE >= V_DTCTRLTPRECE)
               ORDER BY
                  DTCTRLTPRECE
            ) LOOP

               V_VRMOVTPRECE  := CUR_CTRLTPRECEB.VRMOVTPRECE;

               IF CUR_CTRLTPRECEB.IDTPRECE = 'D' THEN
                  V_VRMOVTPRECE  := (-1) * CUR_CTRLTPRECEB.VRMOVTPRECE;
               END IF;

               /*raise_application_error(-20504, CUR_CTRLTPRECEB.DTCTRLTPRECE, True);*/

               /*Retorna o saldo imediatamente anterior*/
               SELECT
                  (NVL(MAX(VRSALTPRECE),0) + V_VRMOVTPRECE)
               INTO V_VRSALDOATUAL
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = P_CDFILIAL) AND
                  (CDLOJA        = P_CDLOJA  ) AND
                  (DTCTRLTPRECE  = (SELECT
                                      MAX(DTCTRLTPRECE)
                                    FROM
                                       CTRLTPRECEB
                                    WHERE
                                      (CDFILIAL     = P_CDFILIAL      ) AND
                                      (CDLOJA       = P_CDLOJA        ) AND
                                      (DTCTRLTPRECE < CUR_CTRLTPRECEB.DTCTRLTPRECE)));

               /*Atualiza os registross*/
               UPDATE
                  CTRLTPRECEB
               SET
                  VRSALTPRECE  = V_VRSALDOATUAL
               WHERE
                  (CDFILIAL     = P_CDFILIAL) AND
                  (CDLOJA       = P_CDLOJA  ) AND
                  (DTCTRLTPRECE = CUR_CTRLTPRECEB.DTCTRLTPRECE);
            END LOOP;
         END IF;
      END IF;

      IF V_REGMENORIGUAL > 1 THEN
         /*Seleciona os registros a partir do atual.*/
         FOR CUR_CTRLTPRECEB IN (
            SELECT
               CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL      = P_CDFILIAL    ) AND
               (CDLOJA        = P_CDLOJA      ) AND
               (DTCTRLTPRECE >= V_DTCTRLTPRECE)
            ORDER BY
               DTCTRLTPRECE
         ) LOOP

            /*qrySaldoAnte*/
            V_VRMOVTPRECE  := CUR_CTRLTPRECEB.VRMOVTPRECE;

            IF CUR_CTRLTPRECEB.IDTPRECE = 'D' THEN
               V_VRMOVTPRECE  := (-1) * CUR_CTRLTPRECEB.VRMOVTPRECE;
            END IF;

            SELECT
               (NVL(MAX(VRSALTPRECE),0)  + V_VRMOVTPRECE)
            INTO V_VRSALDOATUAL
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL     = P_CDFILIAL) AND
               (CDLOJA       = P_CDLOJA  ) AND
               (DTCTRLTPRECE = (SELECT
                                    MAX(DTCTRLTPRECE)
                                 FROM
                                    CTRLTPRECEB
                                 WHERE
                                    (CDFILIAL     = P_CDFILIAL) AND
                                    (CDLOJA       = P_CDLOJA  ) AND
                                    (DTCTRLTPRECE < CUR_CTRLTPRECEB.DTCTRLTPRECE)));

            /*qryAtualiza*/
            UPDATE
               CTRLTPRECEB
            SET
               VRSALTPRECE  = V_VRSALDOATUAL
            WHERE
               (CDFILIAL     = P_CDFILIAL) AND
               (CDLOJA       = P_CDLOJA  ) AND
               (DTCTRLTPRECE = CUR_CTRLTPRECEB.DTCTRLTPRECE);
         END LOOP;
      END IF;
   END IF;

   IF V_TIPOCALC = '2' THEN
      /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
      SELECT
         MIN(DTCTRLTPRECE)
      INTO V_DTCTRLTPRECE
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = P_CDFILIAL) AND
         (CDLOJA        IS NULL     ) AND
         (DTCTRLTPRECE >= P_DATA    );

      /*Retorna o nmero de registros menores ou iguais  data/hora informada*/
      SELECT
         COUNT(DTCTRLTPRECE)
      INTO V_REGMENORIGUAL
      FROM
         CTRLTPRECEB
      WHERE
         (CDFILIAL      = P_CDFILIAL    ) AND
         (CDLOJA        IS NULL         ) AND
         (DTCTRLTPRECE <= V_DTCTRLTPRECE);

      /*Se a data/hora informada for a primeira o saldo ser atualizado com o valor do prprio registro*/
      IF V_REGMENORIGUAL = 1 THEN

         /*Seleciona o registro*/
         SELECT
            CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
         INTO V_CDFILIAL, V_DTCTRLTPRECE, V_VRMOVTPRECE, V_IDTPRECE, V_VRSALTPRECE
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL     = P_CDFILIAL    ) AND
            (CDLOJA        IS NULL        ) AND
            (DTCTRLTPRECE = V_DTCTRLTPRECE);

         IF V_IDTPRECE = 'D' THEN
            V_VRMOVTPRECE := (-1) * V_VRMOVTPRECE;
         END IF;

         /*Grava no valor do saldo, o valor da venda, visto que no h registro anterior*/
         UPDATE
            CTRLTPRECEB
         SET
            VRSALTPRECE  = V_VRMOVTPRECE
         WHERE
            (DTCTRLTPRECE = V_DTCTRLTPRECE) AND
	         (CDLOJA        IS NULL        ) AND
            (CDFILIAL     = V_CDFILIAL    );

         /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
         SELECT
            COUNT(DTCTRLTPRECE)
         INTO V_MAIORIGUAL
         FROM
            CTRLTPRECEB
         WHERE
            (CDFILIAL      = P_CDFILIAL    ) AND
            (CDLOJA        IS NULL         ) AND
            (DTCTRLTPRECE >= V_DTCTRLTPRECE);

         /*Atualiza registross posteriores*/
         IF V_MAIORIGUAL > 1 THEN
            FOR CUR_CTRLTPRECEB IN (
               SELECT
                  CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = P_CDFILIAL    ) AND
			         (CDLOJA        IS NULL         ) AND
                  (DTCTRLTPRECE >= V_DTCTRLTPRECE)
               ORDER BY
                  DTCTRLTPRECE
            ) LOOP

               V_VRMOVTPRECE  := CUR_CTRLTPRECEB.VRMOVTPRECE;

               IF CUR_CTRLTPRECEB.IDTPRECE = 'D' THEN
                  V_VRMOVTPRECE  := (-1) * CUR_CTRLTPRECEB.VRMOVTPRECE;
               END IF;

               /*raise_application_error(-20504, CUR_CTRLTPRECEB.DTCTRLTPRECE, True);*/

               /*Retorna o saldo imediatamente anterior*/
               SELECT
                  (NVL(MAX(VRSALTPRECE),0) + V_VRMOVTPRECE)
               INTO V_VRSALDOATUAL
               FROM
                  CTRLTPRECEB
               WHERE
                  (CDFILIAL      = P_CDFILIAL) AND
			         (CDLOJA        IS NULL     ) AND
                  (DTCTRLTPRECE  = (SELECT
                                      MAX(DTCTRLTPRECE)
                                    FROM
                                       CTRLTPRECEB
                                    WHERE
                                      (CDFILIAL     = P_CDFILIAL      ) AND
										         (CDLOJA        IS NULL         ) AND
                                      (DTCTRLTPRECE < CUR_CTRLTPRECEB.DTCTRLTPRECE)));

               /*Atualiza os registross*/
               UPDATE
                  CTRLTPRECEB
               SET
                  VRSALTPRECE  = V_VRSALDOATUAL
               WHERE
                  (CDFILIAL     = P_CDFILIAL) AND
			         (CDLOJA        IS NULL    ) AND
                  (DTCTRLTPRECE = CUR_CTRLTPRECEB.DTCTRLTPRECE);
            END LOOP;
         END IF;
      END IF;

      IF V_REGMENORIGUAL > 1 THEN
         /*Seleciona os registros a partir do atual.*/
         FOR CUR_CTRLTPRECEB IN (
            SELECT
               CDFILIAL, DTCTRLTPRECE, VRMOVTPRECE, IDTPRECE, VRSALTPRECE
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL      = P_CDFILIAL    ) AND
   	         (CDLOJA        IS NULL         ) AND
               (DTCTRLTPRECE >= V_DTCTRLTPRECE)
            ORDER BY
               DTCTRLTPRECE
         ) LOOP

            /*qrySaldoAnte*/
            V_VRMOVTPRECE  := CUR_CTRLTPRECEB.VRMOVTPRECE;

            IF CUR_CTRLTPRECEB.IDTPRECE = 'D' THEN
               V_VRMOVTPRECE  := (-1) * CUR_CTRLTPRECEB.VRMOVTPRECE;
            END IF;

            SELECT
               (NVL(MAX(VRSALTPRECE),0)  + V_VRMOVTPRECE)
            INTO V_VRSALDOATUAL
            FROM
               CTRLTPRECEB
            WHERE
               (CDFILIAL     = P_CDFILIAL) AND
		         (CDLOJA        IS NULL    ) AND
               (DTCTRLTPRECE = (SELECT
                                    MAX(DTCTRLTPRECE)
                                 FROM
                                    CTRLTPRECEB
                                 WHERE
                                    (CDFILIAL     = P_CDFILIAL) AND
									         (CDLOJA        IS NULL    ) AND
                                    (DTCTRLTPRECE < CUR_CTRLTPRECEB.DTCTRLTPRECE)));

            /*qryAtualiza*/
            UPDATE
               CTRLTPRECEB
            SET
               VRSALTPRECE  = V_VRSALDOATUAL
            WHERE
               (CDFILIAL     = P_CDFILIAL) AND
   	         (CDLOJA        IS NULL    ) AND
               (DTCTRLTPRECE = CUR_CTRLTPRECEB.DTCTRLTPRECE);
         END LOOP;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_SALDO_TICKET','4.05.136'); END;
/

