/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GPPR                                                     */
/* Tabela : GRUPPROD                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 03/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GPPR'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GPPR
GO

CREATE TRIGGER DTULTATU_GPPR
ON GRUPPROD
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPPROD', null, 'CDGRUPPROD=' + CDGRUPPROD + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPPROD
      SET DTULTATUGPPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(GRUPPROD.CDGRUPPROD,0)  = ISNULL(INSERTED.CDGRUPPROD,0));
   END;
END;
GO

UPDATE GRUPPROD SET DTULTATUGPPR = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUGPPR IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUGPPR' and
            type = 'D')
   ALTER TABLE GRUPPROD DROP CONSTRAINT DEFAULT_DTULTATUGPPR
GO

ALTER TABLE GRUPPROD ADD CONSTRAINT DEFAULT_DTULTATUGPPR
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUGPPR
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GPPR','4.11.194';
GO

