<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\Repositories;

class FpaDirfmagnet extends \Doctrine\ORM\EntityRepository {
    
    public function _temMagneticoDirf($nrVinc, $nrorgTrab, $dtMesCompetenc){
        
        $db = \Setforms2\Shared\Registry::getEntityManagerConnection();
        
        $params = array(
            'P_NRORG'=>$nrorgTrab,
            'P_NRVINCULOM'=>$nrVinc,
            'P_DTMESCOMPETENC'=>$dtMesCompetenc,
        );

$sql = <<<SQL
SELECT 1 AS TEMLINHA
  FROM GPE_VINCULOM
 WHERE GPE_VINCULOM.NRORG = :P_NRORG
   AND GPE_VINCULOM.NRVINCULOM = :P_NRVINCULOM
    AND
       EXISTS (SELECT 1 
                 FROM FPA_DIRFMAGNET D, GPE_PESSOAH H 
                WHERE H.NRORG = GPE_VINCULOM.NRORG 
                  AND D.NRORG = GPE_VINCULOM.NRORG 
                  AND H.NRPESSOA = GPE_VINCULOM.NRPESSOA
                  AND H.NRCPFPESSOA = D.NRCPFPESSOA
                  AND D.MESCOMPETENCIA = :P_DTMESCOMPETENC)
SQL;
        $result = $db->fetchAll($sql,$params);

        if(isset($result[0])) return $result[0];
        else return null;
    }
    
    public function retornaRegistrosPorInscricao($nrOrg, $mesCompetencia, $cdInscEstrut){
         
        $fpaDirfmagnet = Repositories::FPA_DIRFMAGNET;

        $sql = <<<SQL
SELECT mg
FROM $fpaDirfmagnet mg
WHERE mg.nrorg = :nrorg AND
      mg.mescompetencia = :mescompetencia AND 
      mg.cdinscestrut = :cdinscestrut
SQL;
        $params = array(
            'nrorg' => $nrOrg,
            'mescompetencia' => $mesCompetencia,
            'cdinscestrut' => $cdInscEstrut,
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaRegistrosTrabalhador($nrOrg, $mesCompetencia, $cdInscEstrut, $nrCpfPessoa){
        $fpaDirfmagnet = Repositories::FPA_DIRFMAGNET;

        $sql = <<<SQL
SELECT mg
FROM $fpaDirfmagnet mg
WHERE mg.nrorg = :nrorg AND
      mg.mescompetencia = :mescompetencia AND 
      mg.cdinscestrut = :cdinscestrut AND
      gf.nrcpfpessoa = :nrcpfpessoa
SQL;
        $params = array(
            'nrorg' => $nrOrg,
            'mescompetencia' => $mesCompetencia,
            'cdinscestrut' => $cdInscEstrut,
            'nrcpfpessoa' => $nrCpfPessoa,
        );
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
}