function exp00600_relatorio_consumo_na_expedicao_Controller(templateManager, restEngine, General, ScreenService, ZhFilterPreferences, ZHPromise,MessageService){
	var somadorFields = 3;//4->NOTAFIS, 5->NRPEDIDO
	
	var verificadorFields = {
		"CDFILIAL": false,
		"DATAINICIAL": false,
		"CDCLIENTE": true,
		"TIPOOPER": true,
		"NOTAFIS": true
	};
	
	this.filterOnEnter = function(widget){
        var promises = [];
        promises.push(ZhFilterPreferences.setOriginalFilter(widget.id));
        promises.push(ZhFilterPreferences.openFilterWidget(widget));
        ZHPromise.all(promises).then(function(rowSetFilter){
        	
        }.bind(this)); 
    };
	
    this.filterBuilder = function () {
        var activeWidget = templateManager.container.getActiveWidget();
        var nome;
        var exp = /\b(NM|DT|NRL)[A-Z]*/;//nao precisam ser montados no filtro
        var exp1 = /\b(CDCLIENTE|TIPOOPER|NOTAFIS|NRPEDIDO|CDVENDEDOR)/;//montados no filtro com operador IN
        var exp2 = /\b(TODOS|TODAS)/;//Campos que precisam passar o filtro "T" mesmo quando não preenchidos
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter = [];
        
        templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
        	{
        		"name": "P_PRODFIM",
        		"operator": "=",
        		"value": activeWidget.currentRow.CDPRODUTO
        	}
        );
        
        activeWidget.fields.forEach(function (field) {
        	
            if(field.value() != "" && field.value() != null && !field.name.match(exp) && field.name != 'SEARCHLIST__ALL') {
                nome = nomes[field.name];
	               
	            if(field.name.match(exp1)){
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name": nome,
	                        "operator": "IN",
	                        "value": field.value().join(',')
	                    }
	                );
	            } else{
	                templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                    {
	                        "name":  nome,
	                        "operator": "=",
	                        "value": field.value()
	                    }
	                );
	            }
            } else if(field.value() === undefined && field.name.match(exp2)){
            	nome = nomes[field.name];
            	templateManager.container.getWidget('relatorio_consumo_expedicao').dataSourceFilter.push(
	                {
	                    "name":  nome,
	                    "operator": "=",
	                    "value": "T"
	                }
	            );
            }
        });
    };
    
    this.filterCDARVPRODFIN = function() {
    	var prodIni = templateManager.container.getActiveWidget().getField('CDARVPRODINI');
    	var prodFin = templateManager.container.getActiveWidget().getField('CDARVPRODFIN');
    	prodFin.dataSourceFilter = [];
    	
    	var filtro = [
            {
                "name": "CDARVPROD",
                "operator": ">=",
                "value": prodIni.value()
            }
        ];
        
        prodFin.dataSourceFilter = filtro;
    };
    
    this.changeTemplate = function (field, fieldToChange) {
        var missingFields = [];
        var prop;
        
        if(field.value() == "T") {
            fieldToChange.readOnly = true;
            delete(fieldToChange.filterProperties.validations.required);
            fieldToChange.setValue("");
            
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && !verificadorFields[fieldToChange.name] ) {
            	verificadorFields[fieldToChange.name] = true;
            	somadorFields++;
            }
            
            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = false;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = false;
            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = false;
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = false;
	            	}
	            	
	            	if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').value() == 'L') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = false;
	            	}
	            	
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = false;
	            		if(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').value() == 'L') {
		            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = false;
		            	}
	            	}
	            }
            
            templateManager.updateTemplate();
        } else {
            if(field.name != 'TODOSNRPEDIDO' && field.name!= 'TODOSCDVENDEDOR' && verificadorFields[fieldToChange.name]) {
            	verificadorFields[fieldToChange.name] = false;
        		somadorFields--;
            }
            
        	if(fieldToChange.name == 'NOTAFIS' && somadorFields < 4) {
    			verificadorFields[fieldToChange.name] = true;
    			somadorFields++;
        		
        		for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){
        
        		var missing_fields = missingFields.join(', ');
				var var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(var_precisa_ser_preenchido,{"MISSING": missing_fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
        		
        		
        	} else if (fieldToChange.name == 'NRPEDIDO' && somadorFields < 5) {
    			
    			for (prop in verificadorFields) {
        			if(!verificadorFields[prop]) {
        				missingFields.push(templateManager.container.getWidget('relatorio_consumo_expedicao').getField(prop).label);
        			}
        		}
        		
    			templateManager.updateTemplate();
        		//ScreenService.showMessage('Os campos ' + missingFields.join(', ') + ' precisam ser preenchidos').then(function(){

        		var missing_Fields = missingFields.join(', ');
				var Var_precisa_ser_preenchido = "PRECISA_SER_PREENCHIDO";
				MessageService.showMessageByCode(Var_precisa_ser_preenchido,{"MISSING": missing_Fields}).then(function(){
        			field.setValue('T');
        			missingFields = [];
        		});
    			
        	} else{
	            fieldToChange.readOnly = false;
	            fieldToChange.filterProperties.validations.required = true;
	            if(fieldToChange.name == 'NOTAFIS' || fieldToChange.name == 'NRPEDIDO') {
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDFILIAL').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DTEXPEDICAO').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('CDCLIENTE').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODOSTIPOOP').readOnly = true;
	            	templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TIPOOPER').readOnly = true;
	            	if(fieldToChange.name == 'NRPEDIDO') {
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('TODASNOTAFIS').readOnly = true;
	            		templateManager.container.getWidget('relatorio_consumo_expedicao').getField('NOTAFIS').readOnly = true;
	            	}
	            }
	            templateManager.updateTemplate();
        	}
        }
    };
    
    this.validaProdutoAte = function () {
    	var activeWidget = templateManager.container.getActiveWidget();
        var produtoFinal = activeWidget.getField('CDARVPRODFIN');
		var produtoInicial_isSelected = !!activeWidget.currentRow.CDARVPRODINI;
		
		if(produtoInicial_isSelected){
			produtoFinal.validations.required = true;
		}else{
			delete(produtoFinal.validations.required);
			activeWidget.getField('NMPRODFIN').setValue(null);
		}
		
		produtoFinal.readOnly = !produtoInicial_isSelected;
		produtoFinal.setValue(null);
		produtoFinal.needReload = true;
    };
    
    this.prodFinal = function(widget){
		var limite = widget.currentRow.INICIAL;
		var arrayProdFinal = widget.getField('CDARVPRODFIN').dataSource.data;

		arrayProdFinal.splice(0, limite-1);
	};
	
	this.validaDatas = function (args) {
	    var expedicao = args.owner.field;
	    
	    if(expedicao.value().start != "" && expedicao.value().start != null) {
            args.row.DATAINICIAL = expedicao.value().start;
            args.row.DATAFINAL = expedicao.value().end;
	    } else {
	        args.row.DATAINICIAL = null;
	        args.row.DATAFINAL = null;
	    }
	    this.validaFields(templateManager.container.getWidget('relatorio_consumo_expedicao').getField('DATAINICIAL'));
	};
	
	
	//verificadorFields serve para a verificacao de fields necessarios aos campos NOTAFIS e NRPEDIDO
	this.validaFields = function(field) {
		if(field.value() != "" && field.value() != null && !verificadorFields[field.name]) {
			verificadorFields[field.name] = true;
			somadorFields++;
		} else if ((field.value() == "" || field.value() == null) && verificadorFields[field.name]) {
			verificadorFields[field.name] = false;
			somadorFields--;
		}
	};
	//modificar conteudo do field se dataSource nao entregar o esperado ao datasource da tela
	this.valueBuilder = function(field){
	    var filterRow = templateManager.container.getWidget('relatorio_consumo_expedicao').currentRow;
	    var valor = [];	
	    	
	    	for(var i = 0; i < filterRow.IDENTRSAIDOP.length ; i++) {
	    		valor.push(filterRow.IDENTRSAIDOP[i] + filterRow.CDTIPOOPER[i]);
	    	}
	    	
	        field.setValue(valor);
	};
	
	this.eventTest = function() {
		console.log('teste');
	};
	
	var nomes = {
	    "CDFILIAL": "P_CDFILIAL",
	    "DATAINICIAL": "P_DATAINI",
	    "DATAFINAL": "P_DATAFINAL",
	    "TODOSCLIENTE": "P_TODOS",
	    "CDCLIENTE": "P_CLIENTE",
	    "TODOSTIPOOP": "P_TTIPO",
	    "TIPOOPER": "P_TIPO",
	    "TODASNOTAFIS": "P_TNOTFIS",
	    "NOTAFIS": "P_NOTFIS",
	    "TODOSNRPEDIDO": "P_NRPEDTODOS2",
	    "NRPEDIDO": "P_NRPEDLISTA",
	    "TODOSCDVENDEDOR": "P_TVENDEDOR",
	    "CDVENDEDOR": "P_CDVENDEDOR",
	    "CDARVPRODINI": "P_PRODINIC",
	    "CDARVPRODFIN": "P_PRODFINAL",
	    "NVPROD": "P_NVPROD"
	};
	
}


Configuration(function(ContextRegister) {
    ContextRegister.register('exp00600_relatorio_consumo_na_expedicao_Controller', exp00600_relatorio_consumo_na_expedicao_Controller);
});