function parametrosDePedidos() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		z.component.menu.clickByPath(['Pedidos', 'Parâmetros de Pedidos']);
		geral.esperarLoading();
	};

	this.editarNacimentoNovoPedido = (statusLancamento, clientePadrao, clienteOrcamento, modalidadePadrao,
		vendedorPadrao, numeroDeDiasUteis) => {
		geral.clickEditar();
		geral.selectNative('IDLANCPED', statusLancamento);
		geral.searchAndClickGridField('NMFANTCLIE', clientePadrao, 'NMRAZSOCCLIE');
		geral.searchAndClickGridField('NMFANTCLIEORC', clienteOrcamento, 'NMRAZSOCCLIE');
		geral.searchAndClickGridField('DSMODPGTO', modalidadePadrao, 'DSMODPGTO');
		geral.searchAndClickGridField('NMRAZSOCVEN', vendedorPadrao, 'NMRAZSOCVEN');
		geral.fillField('NRDIASENTPED', numeroDeDiasUteis);
	};

	this.editarLancamentoPedido = (controlaEmpenho, utilizaControle, utilizaDataValidade, quantidadeDiasValidade, obrigatorioInformarTransportadora,
		informarTipoOperacao, tipoOperacao, permiteAlterarModalidadePagamento, permiteAlterarFormaPagamento, exclusaoPedido) => {		// Empenho
		geral.selectNative('IDUTCTREMPEN', controlaEmpenho);
		geral.selectNative('IDUTCTRELANP', utilizaControle);
		// Data de Validade
		geral.selectNative('IDUTVALIPED', utilizaDataValidade);
		if (utilizaDataValidade == 'Sim') {
			geral.clickAndFllField('QTDIAVALIPED', quantidadeDiasValidade);
		}
		// Validações
		geral.selectNative('IDOBRINFTRAN', obrigatorioInformarTransportadora);
		geral.selectNative('IDOBRTPOPPED', informarTipoOperacao);
		if (informarTipoOperacao == 'Sim') {
			geral.searchAndClickGridField('NMTIPOOPER', tipoOperacao, 'NMTIPOOPER');
		}
		// Bloqueios e Permissões
		geral.selectNative('IDALTMODPAG', permiteAlterarModalidadePagamento);
		geral.selectNative('IDALTFORMAPAG', permiteAlterarFormaPagamento);
		geral.selectNative('IDEXCLPEDIDO', exclusaoPedido);
		geral.clickSalvar();
	};

	this.editarLancamentoItem = (exibePrincipio, numeroMaximo, descontoMaximo, composicaoProduto,
		cliente, filial, transportadora, grupoAutorizacaoLancarPedido) => {
		geral.clickEditar();
		geral.selectNative('IDEXIBPRINATIV', exibePrincipio);
		geral.fillField('NRMAXITNFPED', numeroMaximo);
		geral.selectNative('IDUTDESCMAXI', descontoMaximo);
		geral.selectNative('IDTPCOMPPROD', composicaoProduto);
		geral.selectNative('IDCONFISPRODCLIE', cliente);
		geral.selectNative('IDCONFISPRODFIL', filial);
		geral.selectNative('IDCONFISPRODTRA', transportadora);
		if ((composicaoProduto == 'Sim') || (cliente == 'Sim') || (filial == 'Sim') || (transportadora == 'Sim')) {
			geral.searchAndClickGridField('DSGRUPOPER', grupoAutorizacaoLancarPedido, 'DSGRUPOPER');
		}
		geral.clickSalvar();
	};

	this.editarEstoqueDoItem = (testaEstoque, utilizaReserva, evoluirEstoque, consideraEstoque) => {
		geral.clickEditar();
		geral.selectNative('IDTESTAEST', testaEstoque);
		geral.selectNative('IDUTRESELOTE', utilizaReserva);
		geral.selectNative('IDEVOLESTLIQMAN', evoluirEstoque);
		geral.selectNative('IDCONSESTGEROP', consideraEstoque);
		geral.clickSalvar();
	};

	this.editarPrecoDoProduto = (origemPrecificacao, permiteAlteracao, alteracaoPermitidaMenos,
		alteracaoPermitidaMais, grupoAutorizacaoAlterarValor) => {
		geral.clickEditar();
		geral.selectNative('IDTABPRECO', origemPrecificacao);
		if (origemPrecificacao == 'Tabela de Preço') {
			geral.selectNative('IDPERALTPRECO', permiteAlteracao);
			if (permiteAlteracao == 'Sim') {
				geral.clickAndFllField('DSPERALTMENOR', alteracaoPermitidaMenos);
				geral.clickAndFllField('DSPERALTMAIOR', alteracaoPermitidaMais);
				geral.searchAndClickGridField('DSGRUALTPRECO', grupoAutorizacaoAlterarValor, 'DSGRUPOPER');
			}
		}
		geral.clickSalvar();
	};

	this.editarInformacoesFinanceiras = (pendenciaFinanceira, diasDePendencia, verificaPendencia,
		situacaoFinanceira, limiteAprovacao, bloqueiaAprovacao, grupoOperadores) => {
		geral.clickEditar();
		geral.selectNative('IDPENDFINAN', pendenciaFinanceira);
		if (pendenciaFinanceira != 'Não verifica pendência financeira do cliente') {
			geral.clickAndFllField('NRDIAPENDFIN', diasDePendencia);
			geral.selectNative('IDPENDFINANLANC', verificaPendencia);
		}
		geral.selectNative('IDSITUFINAN', situacaoFinanceira);
		if (situacaoFinanceira != 'Não verifica situação financeira do cliente') {
			geral.clickAndFllField('VRLIMAPROVA', limiteAprovacao);
		}
		geral.selectNative('IDBLOQAPROVACAO', bloqueiaAprovacao);
		geral.searchAndClickGridField('DSGROPERAPRO', grupoOperadores, 'DSGRUPOPER');
		geral.clickSalvar();
	};

	this.editarDadosComissao = (origemComissao, defineEncargo, exibeTelaCadastro) => {
		geral.clickEditar();
		geral.selectNative('IDCTRLVENEXP', origemComissao);
		geral.selectNative('IDENCARPRIPARC', defineEncargo);
		geral.selectNative('IDEXIBVENDCOM', exibeTelaCadastro);
		geral.clickSalvar();
	};

	this.editarOperacoesComImpostos = (exibeImpostos, permiteInformarEncargo) => {
		geral.clickEditar();
		geral.selectNative('IDEXIBIMPITPED', exibeImpostos);
		geral.selectNative('IDLANENCARGOPED', permiteInformarEncargo);
		geral.clickSalvar();
	};

	this.editarAcesso = (pedidos, grupoOperadores, utilizaRelacionamento, mensagemVendedor,
		consultaProduto, valorMinimo) => {
		geral.clickEditar();
		geral.selectNative('IDEXIBPEDIDO', pedidos);
		if (pedidos == 'Apenas do operador logado') {
			geral.searchAndClickGridField('DSGRUPOPTPED', grupoOperadores, 'DSGRUPOPER');
		}
		geral.selectNative('IDUTRELACVENDCLI', utilizaRelacionamento);
		geral.selectNative('IDMENSVEND', mensagemVendedor);
		geral.selectNative('IDESTTODFIL', consultaProduto);
		geral.clickAndFllField('VRMINPEDIDO', valorMinimo);
		geral.clickSalvar();
	};
}

module.exports = new parametrosDePedidos();
